.386 
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc
include \masm32\include\ole32.inc 
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\ole32.lib

Unknown STRUCT 
   QueryInterface      DWORD   ? 
   AddRef         DWORD   ? 
   Release         DWORD   ? 
Unknown ends 

ITaskbarList STRUCT 
   IUnknown      Unknown   <> 
    
   HrInit         DWORD   ? 
   AddTab         DWORD   ? 
   DeleteTab      DWORD   ? 
   ActivateTab      DWORD   ? 
   SetActiveAlt      DWORD   ? 
ITaskbarList ends 

.const 
sCLSID_ITaskbarList   textequ      <{056fdf344H, 0fd6dH, 011D0H,\ 
            {095H, 08ah, 000H, 060H, 097H, 0c9H, 0a0H, 090H}}> 

sIID_ITaskbarList   textequ      <{056FDF342H, 0FD6DH, 011D0H,\ 
            {095H, 08AH, 000H, 060H, 097H, 0C9H, 0A0H, 090H}}> 

.data 
CLSID_ITaskbarList   GUID      sCLSID_ITaskbarList 
IID_ITaskbarList   GUID      sIID_ITaskbarList 

.code
DllEntry proc hInstDLL:HINSTANCE, reason:DWORD, reserved1:DWORD
        mov eax,TRUE 
        ret 
DllEntry endp 

ShowTab proc hWnd:DWORD,fShow:DWORD 
   LOCAL ptb   :DWORD 

   invoke CoCreateInstance,ADDR CLSID_ITaskbarList,NULL,CLSCTX_INPROC_SERVER,\ 
      ADDR IID_ITaskbarList,ADDR ptb 
   .IF eax != S_OK 
      mov eax,-1 
      ret 
   .endif 

   push ptb 
   mov edi,ptb 
   mov edi,[edi] 
   call [edi].ITaskbarList.HrInit 
   .IF eax != S_OK 
      push ptb 
      call [edi].ITaskbarList.IUnknown.Release 
      mov eax,-1 
      ret 
   .endif 

   push hWnd 
   push ptb 
   .IF fShow 
      call [edi].ITaskbarList.AddTab 
   .ELSE 
      call [edi].ITaskbarList.DeleteTab 
   .ENDIF 
   .IF eax != S_OK 
      push ptb 
      call [edi].ITaskbarList.IUnknown.Release 
      mov eax,-1 
      ret 
   .endif 

   push ptb 
   call [edi].ITaskbarList.IUnknown.Release 

   xor eax,eax 

   ret 
ShowTab endp

End DllEntry